


#include "ModbusSlave232.h"

// Create new mbs instance
ModbusSlave232 mbs;


int RegCommand     = 0;   // copy of command register
int rc;                   // return code for MODBUS stack calls

#define MB_REGS     16   // array boundary for modbus registers
int regs[MB_REGS];

#define REG_STATUS   0
#define REG_CMD      7  // command register

int iCnt=0;

// Compare Time for deleays
unsigned long Tmilli = 0;
  
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

void setup() 
{
  // Modbus slave configuration parameters³³
  // SlaveId 
  const unsigned char SLAVE = 1;
  // Baud rate
  const long BAUD = 115200;
  const unsigned PARITY = 'n';

  // Configure msb with config settings
  mbs.configure(SLAVE, BAUD, PARITY );

  Serial2.begin(115200);
}

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

void loop() 
{
  static bool bFirstRun = true;  
  rc = mbs.update(regs, MB_REGS);

  if(bFirstRun)
  {
    Serial2.print("\n\n### ModbusTest ###\n\n");
    bFirstRun = false;
  }

  int i;

  if(Tmilli < millis())
  {
    //DumpBuf(regs, MB_REGS);
    Serial2.println(iCnt++);
    Serial2.println(regs[REG_STATUS]);
    Serial2.println(regs[REG_CMD]);
    Serial2.println(regs[REG_CMD-1]);
    Serial2.println();
    Tmilli = millis() + 1000;
  }
}
